// TermHireApp.cpp
// v1.05
// version for R4 release of the BeOS, for both Intel and PowerPC platforms
// release date 26 November 1998
// contact : brua@caids.u-strasbg.fr

// This code is intended to help the user install TermHire :
// If Termhire is launched from a Terminal or from the Tracker, it pops
// up an installation window
#include <Alert.h>
#include <Application.h>
#include <BeBuild.h>
#include <FindDirectory.h>
#include <Path.h>

#include "TermHireApp.h"
#include "TermHireUtils.h"
#include <string.h>

TermHireApp :: TermHireApp()
	: BApplication("application/x-vnd.brua-termhire")
{
}

bool TermHireApp :: QuitRequested()
{
	return TRUE;
}

void TermHireApp :: ReadyToRun()
{
	char InfoString[2048];
	BMessage *msg;
	BMessenger *messenger; // to launch the doc under StyledEdit
	app_info info; // app_info of TermHire executable
	BPath *path; // path of TermHire executable
	BPath *parent_path; // TermHire parent directory
	char my_path[B_PATH_NAME_LENGTH], *install_file, *install_dir;
	char *argv[ARGC];

	// I search for me (my file) in the app information
	if ( GetAppInfo(&info) == B_OK )
	{
		path = new BPath();
		(BEntry (&info.ref)).GetPath(path);
		strcpy(my_path,path->Path());
	} 
	else
	// something odd occured : I can't find myself !
	{
		BAlert *alert = new BAlert("TermHire"," I cannot find the file you launched, sorry",
			"Check TermHire Home Page for info","Exit",NULL,B_WIDTH_FROM_LABEL,B_STOP_ALERT);
			PostMessage(B_QUIT_REQUESTED);
	}
	strcpy(InfoString, "TermHire " VERSION " by Pierre Brua (brua@caids.u-strasbg.fr).\nI'm a Tracker add-on, I would like to install myself in the correct folder");
	BAlert *alert = new BAlert("TermHire Information", 
		InfoString,
		"Show me the manual install instructions","Cancel","Install automatically",
		B_WIDTH_FROM_LABEL,B_INFO_ALERT);
	switch(alert->Go())
	{
		case 1 :
			break;
		case 0 :
			// we launch the "install.html" file under NetPositive
			path->GetParent(parent_path=new BPath());
			install_file = new char[B_PATH_NAME_LENGTH];
			strcpy(install_file,"file://");
			strcat(install_file,parent_path->Path());
			strcat(install_file,"/install.html");
			msg = new BMessage(B_ARGV_RECEIVED); 
			
			msg->AddString("argv", "NetPositive"); 
			msg->AddString("argv", install_file); 
			msg->AddInt32("argc", 2); 
			
			messenger = new BMessenger ("application/x-vnd.be-npos", -1, NULL); 
			
			if (messenger->IsValid()) { 
			  messenger->SendMessage( msg ); 
			} else { 
			  be_roster->Launch ("application/x-vnd.be-npos", msg ); 
			} 
			break;
		case 2 :
			// we launch a thread executing the Install script in a Terminal window
			install_dir = new char[B_PATH_NAME_LENGTH];
			install_file = new char[B_PATH_NAME_LENGTH];
			path->GetParent(parent_path=new BPath());
			strcpy(install_dir,parent_path->Path());
			strcpy(install_file,install_dir);
			strcat(install_file,"/Install");
			if(configure_argv(argv))
			{
				argv[2]=install_file;
				LaunchTerminal(3,(const char **)argv,(const char *)install_dir);
			}
/*			thread_id tid;
			path->GetParent(parent_path=new BPath());
			char *argv3[4]={"/boot/beos/apps/Terminal" ,"/boot/beos/bin/sh",install_file};
			tid=load_image(3,argv3,environ);
			if (tid > 0)
			{
				// the launch was successful, now run the thread
				resume_thread(tid);
			}
			else 
			{
				// the launch was unsuccessful
				error("Impossible de lancer le script d'install");
			}*/
			break;
		default : break;
	}			
	PostMessage(B_QUIT_REQUESTED);
}

int main()
{
	TermHireApp *app = new TermHireApp;
	app->Run();
	delete app;
}

void MakeInfoString(char *InfoString)
{
	strcpy(InfoString, VERSION " by Pierre Brua.\nThis program is a Tracker add-on. Put it in ");
//	find_directory(B_USER_ADDONS_DIRECTORY, NULL, false, InfoString + strlen(InfoString), 1024);
	strcat(InfoString, "/Tracker.");
	error(InfoString);
}
